
#include <classes/Layouter/DecorGadgets.h>

LBBevelboxC::LBBevelboxC(WindowC &w, STRPTR Label, BoopsiImageC *im,
		WORD Width, WORD Height, struct TagItem *tags)
	: BBevelboxC(w,
		GA_Width, (ULONG) Width,
		GA_Height, (ULONG) Height,
		GA_Text, Label,
		BBA_Pattern, im ? im->object() : NULL,
		TAG_MORE, tags)
{
	aWidth = (Width == LAYOUT_AUTOSIZE);
	aHeight = (Height == LAYOUT_AUTOSIZE);
}

LBBevelboxC::LBBevelboxC(WindowC &w, STRPTR Label, BoopsiImageC *im,
		WORD Width, WORD Height, Tag tag1type, ...)
	: BBevelboxC(w,
		GA_Width, (ULONG) Width,
		GA_Height, (ULONG) Height,
		GA_Text, Label,
		BBA_Pattern, im ? im->object() : NULL,
		TAG_MORE, (struct TagItem *) &tag1type)
{
	aWidth = (Width == LAYOUT_AUTOSIZE);
	aHeight = (Height == LAYOUT_AUTOSIZE);
}

BOOL LBBevelboxC::layoutWidth()
{
	if (aWidth)
		setWidth(0);
	return FALSE;
}

BOOL LBBevelboxC::layoutHeight()
{
	if (aHeight)
		setHeight(0);
	return FALSE;
}

VOID LBBevelboxC::setWidth(WORD w)
{
	setAttrs(GA_Width,(ULONG) w, TAG_END);
	if (w == LAYOUT_AUTOSIZE)
		aWidth = TRUE;
};

VOID LBBevelboxC::setHeight(WORD h)
{
	setAttrs(GA_Height,(ULONG) h, TAG_END);
	if (h == LAYOUT_AUTOSIZE)
		aHeight = TRUE;
};

// *************************************************************

LBBevellineC::LBBevellineC(WindowC &w, STRPTR Label,
		WORD Width, WORD Height, struct TagItem *tags)
	: BBevellineC(w,
		GA_Width, (ULONG) Width,
		GA_Height, (ULONG) Height,
		GA_Text, Label,
		TAG_MORE, tags)
{
	aWidth = (Width == LAYOUT_AUTOSIZE);
	aHeight = (Height == LAYOUT_AUTOSIZE);
}

LBBevellineC::LBBevellineC(WindowC &w, STRPTR Label,
		WORD Width, WORD Height, Tag tag1type, ...)
	: BBevellineC(w,
		GA_Width, (ULONG) Width,
		GA_Height, (ULONG) Height,
		GA_Text, Label,
		TAG_MORE, (struct TagItem *) &tag1type)
{
	aWidth = (Width == LAYOUT_AUTOSIZE);
	aHeight = (Height == LAYOUT_AUTOSIZE);
}

BOOL LBBevellineC::layoutWidth()
{
	if (aWidth)
		setWidth(0);
	return FALSE;
}

BOOL LBBevellineC::layoutHeight()
{
	if (aHeight)
		setHeight(0);
	return FALSE;
}

VOID LBBevellineC::setWidth(WORD w)
{
	setAttrs(GA_Width,(ULONG) w, TAG_END);
	if (w == LAYOUT_AUTOSIZE)
		aWidth = TRUE;
};

VOID LBBevellineC::setHeight(WORD h)
{
	setAttrs(GA_Height,(ULONG) h, TAG_END);
	if (h == LAYOUT_AUTOSIZE)
		aHeight = TRUE;
};
